#' IDs mappable by SBGNview
#' @details ID types mappable to glyph IDs in SBGNhub SBGN-ML file collection: https://github.com/datapplab/SBGNhub/tree/master/data/SBGN.with.stamp
#' @format A list with two elements: A vector of mappable gene ID types, a vector of mappable compound ID types.
'mapped.ids'

#' Information of collected pathways
#' @details The information of pre-collected pathways (SBGNhub: https://github.com/datapplab/SBGNhub/tree/master/data/SBGN.with.stamp) and their SBGN-ML file information, such as pathway ID, name, source database, glyph ID types and URLs to the original pathway webpages.
#' @format A data.frame
'pathways.info'

#' Number of pathways collected
#' @details The number of pathways in SBGNhub from each source database. It is calculated from data 'pathways.info'.
#' @format A data.frame
'pathways.stat'

#' Demo SBGNview object
#' @details An example SBGNview object
#' @format A SBGNview object
'SBGNview.obj'

